## nvidia-graphics-drivers-525 525.147.05

=== kernel-open/Makefile ===
#
# This Makefile was automatically generated; do not edit.
#

###########################################################################
# Makefile for NVIDIA Linux GPU driver kernel modules
###########################################################################

# This makefile is read twice: when a user or nvidia-installer invokes
# 'make', this file is read.  It then invokes the Linux kernel's
# Kbuild.  Modern versions of Kbuild will then read the Kbuild file in
# this directory.  However, old versions of Kbuild will instead read
# this Makefile.  For backwards compatibility, when read by Kbuild
# (recognized by KERNELRELEASE not being empty), do nothing but
# include the Kbuild file in this directory.

ifneq ($(KERNELRELEASE),)
  include $(src)/Kbuild
else

  # Determine the location of the Linux kernel source tree, and of the
  # kernel's output tree.  Use this to invoke Kbuild, and pass the paths
  # to the source and output trees to NVIDIA's Kbuild file via
  # NV_KERNEL_{SOURCES,OUTPUT}.

  ifdef SYSSRC
    KERNEL_SOURCES := $(SYSSRC)
  else
    KERNEL_UNAME ?= $(shell uname -r)
    KERNEL_MODLIB := /lib/modules/$(KERNEL_UNAME)
    KERNEL_SOURCES := $(shell test -d $(KERNEL_MODLIB)/source && echo $(KERNEL_MODLIB)/source || echo $(KERNEL_MODLIB)/build)
  endif

  KERNEL_OUTPUT := $(KERNEL_SOURCES)
  KBUILD_PARAMS :=

  ifdef SYSOUT
    ifneq ($(SYSOUT), $(KERNEL_SOURCES))
      KERNEL_OUTPUT := $(SYSOUT)
      KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
    endif
  else
    KERNEL_UNAME ?= $(shell uname -r)
    KERNEL_MODLIB := /lib/modules/$(KERNEL_UNAME)
    ifeq ($(KERNEL_SOURCES), $(KERNEL_MODLIB)/source)
      KERNEL_OUTPUT := $(KERNEL_MODLIB)/build
      KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
    endif
  endif

  CC ?= cc
  LD ?= ld
  OBJDUMP ?= objdump

  ifndef ARCH
    ARCH := $(shell uname -m | sed -e 's/i.86/i386/' \
      -e 's/armv[0-7]\w\+/arm/' \
      -e 's/aarch64/arm64/' \
      -e 's/ppc64le/powerpc/' \
    )
  endif

  NV_KERNEL_MODULES ?= $(wildcard nvidia nvidia-uvm nvidia-vgpu-vfio nvidia-modeset nvidia-drm nvidia-peermem)
  NV_KERNEL_MODULES := $(filter-out $(NV_EXCLUDE_KERNEL_MODULES), \
                                    $(NV_KERNEL_MODULES))
  NV_VERBOSE ?=
  SPECTRE_V2_RETPOLINE ?= 0

  ifeq ($(NV_VERBOSE),1)
    KBUILD_PARAMS += V=1
  endif
  KBUILD_PARAMS += -C $(KERNEL_SOURCES) M=$(CURDIR)
  KBUILD_PARAMS += ARCH=$(ARCH)
  KBUILD_PARAMS += NV_KERNEL_SOURCES=$(KERNEL_SOURCES)
  KBUILD_PARAMS += NV_KERNEL_OUTPUT=$(KERNEL_OUTPUT)
  KBUILD_PARAMS += NV_KERNEL_MODULES="$(NV_KERNEL_MODULES)"
  KBUILD_PARAMS += INSTALL_MOD_DIR=kernel/drivers/video
  KBUILD_PARAMS += NV_SPECTRE_V2=$(SPECTRE_V2_RETPOLINE)

  .PHONY: modules module clean clean_conftest modules_install
  modules clean modules_install:
	@$(MAKE) "LD=$(LD)" "CC=$(CC)" "OBJDUMP=$(OBJDUMP)" $(KBUILD_PARAMS) $@
	@if [ "$@" = "modules" ]; then \
	  for module in $(NV_KERNEL_MODULES); do \
	    if [ -x split-object-file.sh ]; then \
	      ./split-object-file.sh $$module.ko; \
	    fi; \
	  done; \
	fi

  # Compatibility target for scripts that may be directly calling the
  # "module" target from the old build system.

  module: modules

  # Check if the any of kernel module linker scripts exist. If they do, pass
  # them as linker options (via variable NV_MODULE_LD_SCRIPTS) while building
  # the kernel interface object files. These scripts do some processing on the
  # module symbols on which the Linux kernel's module resolution is dependent
  # and hence must be used whenever present.

  LD_SCRIPT ?= $(KERNEL_SOURCES)/scripts/module-common.lds      \
               $(KERNEL_SOURCES)/arch/$(ARCH)/kernel/module.lds \
               $(KERNEL_OUTPUT)/scripts/module.lds
  NV_MODULE_COMMON_SCRIPTS := $(foreach s, $(wildcard $(LD_SCRIPT)), -T $(s))

  # Use $* to match the stem % in the kernel interface file %-linux.o. Replace
  # "nv" with "nvidia" in $* as appropriate: e.g. nv-modeset-linux.o links
  # nvidia-modeset.mod.o and nvidia-modeset/nv-modeset-interface.o. The kernel
  # interface file must have the .mod.o object linked into it: otherwise, the
  # kernel module produced by linking the interface against its corresponding
  # core object file will not be loadable. The .mod.o file is built as part of
  # the MODPOST process (stage 2),  so the rule to build the kernel interface
  # cannot be defined in the *Kbuild files, which are only used during stage 1.

  %-linux.o: modules
	$(LD) $(NV_MODULE_COMMON_SCRIPTS) -r -o $@ \
	  $(subst nv,nvidia,$*).mod.o $(subst nv,nvidia,$*)/$*-interface.o

  # Kbuild's "clean" rule won't clean up the conftest headers on its own, and
  # clean-dirs doesn't appear to work as advertised.
  clean_conftest:
	$(RM) -r conftest
  clean: clean_conftest

endif # KERNELRELEASE

=== src/nvidia/Makefile ===
###########################################################################
# Makefile for nv-kernel.o
###########################################################################

NV_MODULE_LOGGING_NAME ?= nvidia

VERSION_MK_DIR = ../../

include ../../utils.mk

include srcs.mk

##############################################################################
# Helper functions to determine the compiler type
##############################################################################
GET_COMPILER_TYPE = \
  $(shell $(VERSION_MK_DIR)/nv-compiler.sh type $(1))
##############################################################################

# The source files for nv-kernel.o are all SRCS and SRCS_CXX defined in srcs.mk,
# and the NVIDIA ID string
ALL_SRCS = $(SRCS) $(SRCS_CXX)
ALL_SRCS += $(NVIDSTRING)

SRC_COMMON = ../common
CONDITIONAL_CFLAGS :=

CFLAGS += -include $(SRC_COMMON)/sdk/nvidia/inc/cpuopsys.h

CFLAGS += -I kernel/inc
CFLAGS += -I interface
CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc
CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc/hw
CFLAGS += -I arch/nvalloc/common/inc
CFLAGS += -I arch/nvalloc/common/inc/gsp
CFLAGS += -I arch/nvalloc/common/inc/deprecated
CFLAGS += -I arch/nvalloc/unix/include
CFLAGS += -I inc
CFLAGS += -I inc/os
CFLAGS += -I $(SRC_COMMON)/shared/inc
CFLAGS += -I $(SRC_COMMON)/shared/msgq/inc
CFLAGS += -I $(SRC_COMMON)/inc

CFLAGS += -I $(SRC_COMMON)/uproc/os/libos-v2.0.0/include
CFLAGS += -I $(SRC_COMMON)/uproc/os/common/include
CFLAGS += -I $(SRC_COMMON)/uproc/os/libos-v2.0.0/debug
CFLAGS += -I $(SRC_COMMON)/inc/swref
CFLAGS += -I $(SRC_COMMON)/inc/swref/published

CFLAGS += -I generated
CFLAGS += -I $(SRC_COMMON)/nvswitch/kernel/inc
CFLAGS += -I $(SRC_COMMON)/nvswitch/interface
CFLAGS += -I $(SRC_COMMON)/nvswitch/common/inc/
CFLAGS += -I $(SRC_COMMON)/inc/displayport
CFLAGS += -I $(SRC_COMMON)/nvlink/interface/
CFLAGS += -I $(SRC_COMMON)/nvlink/inband/interface
CFLAGS += -I src/mm/uvm/interface
CFLAGS += -I inc/libraries
CFLAGS += -I src/libraries
CFLAGS += -I inc/kernel

CFLAGS += -Werror-implicit-function-declaration
CFLAGS += -Wwrite-strings
CFLAGS += -fno-common
CFLAGS += -ffreestanding

ifeq ($(TARGET_ARCH),x86_64)
  CFLAGS += -msoft-float
  CFLAGS += -mno-red-zone
  CFLAGS += -mcmodel=kernel
  CFLAGS += -mno-mmx
  CFLAGS += -mno-sse
  CFLAGS += -mno-sse2
  CFLAGS += -mno-3dnow
endif

ifeq ($(TARGET_ARCH),aarch64)
  CFLAGS += -mgeneral-regs-only
  CFLAGS += -march=armv8-a
  CFLAGS += -mstrict-align
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mno-outline-atomics)
endif

CFLAGS += -fno-pic

CFLAGS += -D_LANGUAGE_C
CFLAGS += -D__NO_CTYPE
CFLAGS += -DNVRM
CFLAGS += -DLOCK_VAL_ENABLED=0
CFLAGS += -DPORT_ATOMIC_64_BIT_SUPPORTED=1
CFLAGS += -DPORT_IS_KERNEL_BUILD=1
CFLAGS += -DPORT_IS_CHECKED_BUILD=1
CFLAGS += -DPORT_MODULE_atomic=1
CFLAGS += -DPORT_MODULE_core=1
CFLAGS += -DPORT_MODULE_cpu=1
CFLAGS += -DPORT_MODULE_crypto=1
CFLAGS += -DPORT_MODULE_debug=1
CFLAGS += -DPORT_MODULE_memory=1
CFLAGS += -DPORT_MODULE_safe=1
CFLAGS += -DPORT_MODULE_string=1
CFLAGS += -DPORT_MODULE_sync=1
CFLAGS += -DPORT_MODULE_thread=1
CFLAGS += -DPORT_MODULE_util=1
CFLAGS += -DPORT_MODULE_example=0
CFLAGS += -DPORT_MODULE_mmio=0
CFLAGS += -DPORT_MODULE_time=0
CFLAGS += -DRS_STANDALONE=0
CFLAGS += -DRS_STANDALONE_TEST=0
CFLAGS += -DRS_COMPATABILITY_MODE=1
CFLAGS += -DRS_PROVIDES_API_STATE=0
CFLAGS += -DNV_CONTAINERS_NO_TEMPLATES

CFLAGS += -DINCLUDE_NVLINK_LIB
CFLAGS += -DINCLUDE_NVSWITCH_LIB

CFLAGS += -DNV_PRINTF_STRINGS_ALLOWED=1
CFLAGS += -DNV_ASSERT_FAILED_USES_STRINGS=1
CFLAGS += -DPORT_ASSERT_FAILED_USES_STRINGS=1

ifeq ($(DEBUG),1)
  CFLAGS += -gsplit-dwarf
endif

# Define how to perform dead code elimination: place each symbol in its own
# section at compile time, and garbage collect unreachable sections at link
# time.  exports_link_command.txt tells the linker which symbols need to be
# exported from nv-kernel.o so the linker can determine which symbols are
# unreachable.
CFLAGS += -ffunction-sections
CFLAGS += -fdata-sections
NV_KERNEL_O_LDFLAGS += --gc-sections
EXPORTS_LINK_COMMAND = exports_link_command.txt

ifeq ($(TARGET_ARCH),x86_64)
  COMPILER_TYPE := $(call GET_COMPILER_TYPE, $(CC))
  ENDBR_SUPPORTED := $(call AS_HAS_INSTR, endbr64)

  FCF_SUPPORTED =

  #
  # GCC flags -fcf-protection=branch and -mindirect-branch=extern-thunk can
  # be used together after GCC version 9.4.0. See 
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93654 for details.
  # Check if GCC version is appropriate.
  #
  ifeq ($(COMPILER_TYPE),gcc)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 90400)
  endif

  #
  # Clang version 14.0.0 is required for -fcf-protection=branch to work
  # correctly. See commit
  # https://github.com/llvm/llvm-project/commit/dfcf69770bc522b9e411c66454934a37c1f35332
  #
  ifeq ($(COMPILER_TYPE),clang)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 140000)
  endif

  ifeq ($(FCF_SUPPORTED)-$(ENDBR_SUPPORTED),1-1)
    CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fcf-protection=branch)
  endif
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fno-jump-tables)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch-register)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch=thunk-extern)
endif

CFLAGS += $(CONDITIONAL_CFLAGS)

CC_ONLY_CFLAGS += --std=gnu11
CXX_ONLY_CFLAGS += --std=gnu++11

OBJS = $(call BUILD_OBJECT_LIST,$(ALL_SRCS))

# Define how to generate the NVIDIA ID string
$(eval $(call GENERATE_NVIDSTRING, \
  NVRM_ID, \
  UNIX Open Kernel Module, $(OBJS)))

# Define how to build each object file from the corresponding source file.
$(foreach src, $(ALL_SRCS), $(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))

NV_KERNEL_O = $(OUTPUTDIR)/nv-kernel.o

.PHONY: all
all: $(NV_KERNEL_O)

LINKER_SCRIPT = nv-kernel.ld

$(NV_KERNEL_O): $(OBJS) $(EXPORTS_LINK_COMMAND) $(LINKER_SCRIPT)
	$(call quiet_cmd,LD) \
	  $(NV_KERNEL_O_LDFLAGS) \
	  -T $(LINKER_SCRIPT) \
	  -r -o $(NV_KERNEL_O) $(OBJS) @$(EXPORTS_LINK_COMMAND)
	$(call quiet_cmd,OBJCOPY) \
	  --localize-symbol=memset \
	  --localize-symbol=memcpy \
	  $@

.PHONY: clean
clean:
	$(RM) -rf $(OUTPUTDIR)

=== debian/changelog ===
nvidia-graphics-drivers-525 (525.147.05-0ubuntu2.22.04.1) jammy; urgency=medium

  * End of support for 525 series, transition to 535. LP: #2049635

 -- Bartlomiej Zolnierkiewicz <bartlomiej.zolnierkiewicz@canonical.com>  Tue, 26 Mar 2024 11:59:27 +0100

nvidia-graphics-drivers-525 (525.147.05-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2038514).
  * debian/rules{.defs}:
    - Adjust the anems and URLs to the changes on the Nvidia servers.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 30 Oct 2023 12:33:22 +0100

nvidia-graphics-drivers-525 (525.125.06-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2024675).

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 26 Jun 2023 09:06:53 +0000

nvidia-graphics-drivers-525 (525.116.04-0ubuntu0.22.04.2) jammy; urgency=medium

  * debian/templates/control.in:
    - Add transitional packages for 515/open and 510 (LP: #2024247).

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 16 Jun 2023 17:00:00 +0000

nvidia-graphics-drivers-525 (525.116.04-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2018979).

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 11 May 2023 09:18:34 +0000

nvidia-graphics-drivers-525 (525.105.17-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2012529).

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 27 Mar 2023 11:39:05 +0000

nvidia-graphics-drivers-525 (525.89.02-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2006937):
    - Fixed a bug that could cause banding or flickering of color
      gradients on DisplayPort monitors.
  * debian/templates/control.in:
    - Switch libcuda1 and libnvidia-ml1 Provides to libcuda.so.1 and
      libnvidia-ml.so.1. This makes CUDA (from Multiverse) installable
      again.

 -- Alberto Milone <alberto.milone@canonical.com>  Tue, 28 Feb 2023 10:47:21 +0000

nvidia-graphics-drivers-525 (525.85.05-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2003995):
    - Improved the reliability of suspend and resume on UEFI systems
      when using certain display panels.
    - Fixed a bug that could cause VK_ERROR_DEVICE_LOST when using
      VK_MEMORY_ALLOCATE_DEVICE_ADDRESS_CAPTURE_REPLAY_BIT to
      allocate memory.
    - Disabled Fixed Rate Link (FRL) when using passive DisplayPort
      to HDMI dongles, which are incompatible  with FRL.
  * debian/templates/control.in:
    - Add Conflicts, Replaces, Provides up to libcuda-11.7-1.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 01 Feb 2023 11:50:21 +0000

nvidia-graphics-drivers-525 (525.78.01-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2001703).
  * debian/additional_card_ids,
    debian/additional_runtimepm_ids:
    - Add the missing 2717 ID.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 04 Jan 2023 16:50:08 +0000

nvidia-graphics-drivers-525 (525.60.11-0ubuntu0.22.04.1) jammy; urgency=medium

  * Initial release (LP: #1997087).

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 25 Nov 2022 17:19:06 +0000

=== debian/control ===
Source: nvidia-graphics-drivers-525
Section: non-free/oldlibs
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders:
 Alberto Milone <alberto.milone@canonical.com>,
Vcs-Git: git://github.com/tseliot/nvidia-graphics-drivers.git
Vcs-Browser: https://github.com/tseliot/nvidia-graphics-drivers/tree/525
Build-Depends:
 debhelper (>= 9),
 dpkg-dev (>= 1.17.11~),
 xz-utils,
 dkms,
 libxext6,
 quilt,
 po-debconf,
 dh-modaliases,
 xserver-xorg-dev (>= 2:1.4),
 libglvnd-dev,
 libkmod-dev,
 libpciaccess-dev,
 pkg-config,
 libnvidia-egl-wayland1,
 libc6,
 libx11-6,
 python3,
Standards-Version: 4.1.1
Homepage: http://www.nvidia.com
XS-Autobuild: yes

Package: nvidia-driver-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-driver-535
Description: NVIDIA driver metapackage (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-kernel-source-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-kernel-source-535
Description: NVIDIA kernel source package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-dkms-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-dkms-535
Description: NVIDIA DKMS package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-utils-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-utils-535
Description: NVIDIA driver support binaries (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-compute-525
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-compute-535
Description: NVIDIA libcompute package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-compute-utils-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-compute-utils-535
Description: NVIDIA compute utilities (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-no-dkms-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-no-dkms-535
Description: NVIDIA headless metapackage - no DKMS (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-535
Description: NVIDIA headless metapackage (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-kernel-common-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-kernel-common-535
Description: Shared files used with the kernel module (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-gl-525
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-gl-535
Description: NVIDIA OpenGL/GLX/EGL/GLES GLVND libraries and Vulkan ICD (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-common-525
Architecture: all
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: libnvidia-common-535
Description: Shared files used by the NVIDIA libraries (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-extra-525
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-extra-535
Description: Extra libraries for the NVIDIA driver (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: xserver-xorg-video-nvidia-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: xserver-xorg-video-nvidia-535
Description: NVIDIA binary Xorg driver (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-cfg1-525
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-cfg1-535
Description: NVIDIA binary OpenGL/GLX configuration library (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-fbc1-525
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-fbc1-535
Description: NVIDIA OpenGL-based Framebuffer Capture runtime library (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-decode-525
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-decode-535
Description: NVIDIA Video Decoding runtime libraries (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-encode-525
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-encode-535
Description: NVENC Video Encoding runtime library (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-driver-525-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-driver-535-open
Description: NVIDIA driver (open kernel) metapackage (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-kernel-source-525-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-kernel-source-535-open
Description: NVIDIA kernel source package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-dkms-525-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-dkms-535-open
Description: NVIDIA DKMS package (open kernel module) (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-no-dkms-525-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-no-dkms-535-open
Description: NVIDIA headless metapackage - no DKMS (open kernel module) (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-525-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-535-open
Description: NVIDIA headless metapackage (open kernel module) (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-driver-520
Architecture: amd64 arm64
Depends: nvidia-driver-535
Multi-Arch: foreign
Description: Transitional package for nvidia-driver-535
 This is a transitional package for nvidia-driver-535, and can be
 safely removed after the installation is complete.

Package: nvidia-kernel-source-520
Architecture: amd64 arm64
Depends: nvidia-kernel-source-535
Multi-Arch: foreign
Description: Transitional package for nvidia-kernel-source-535
 This is a transitional package for nvidia-kernel-source-535, and can be
 safely removed after the installation is complete.

Package: nvidia-dkms-520
Architecture: amd64 arm64
Depends: nvidia-dkms-535
Multi-Arch: foreign
Description: Transitional package for nvidia-dkms-535
 This is a transitional package for nvidia-dkms-535, and can be
 safely removed after the installation is complete.

Package: nvidia-utils-520
Architecture: amd64 arm64
Depends: nvidia-utils-535
Multi-Arch: same
Description: Transitional package for nvidia-utils-535
 This is a transitional package for nvidia-utils-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-compute-520
Architecture: i386 amd64 arm64
Depends: libnvidia-compute-535
Multi-Arch: same
Description: Transitional package for libnvidia-compute-535
 This is a transitional package for libnvidia-compute-535, and can be
 safely removed after the installation is complete.

Package: nvidia-compute-utils-520
Architecture: amd64 arm64
Depends: nvidia-compute-utils-535
Multi-Arch: same
Description: Transitional package for nvidia-compute-utils-535
 This is a transitional package for nvidia-compute-utils-535, and can be
 safely removed after the installation is complete.

Package: nvidia-headless-no-dkms-520
Architecture: amd64 arm64
Depends: nvidia-headless-no-dkms-535
Multi-Arch: same
Description: Transitional package for nvidia-headless-no-dkms-535
 This is a transitional package for nvidia-headless-no-dkms-535, and can be
 safely removed after the installation is complete.

Package: nvidia-headless-520
Architecture: amd64 arm64
Depends: nvidia-headless-535
Multi-Arch: same
Description: Transitional package for nvidia-headless-535
 This is a transitional package for nvidia-headless-535, and can be
 safely removed after the installation is complete.

Package: nvidia-kernel-common-520
Architecture: amd64 arm64
Depends: nvidia-kernel-common-535
Multi-Arch: same
Description: Transitional package for nvidia-kernel-common-535
 This is a transitional package for nvidia-kernel-common-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-gl-520
Architecture: i386 amd64 arm64
Depends: libnvidia-gl-535
Multi-Arch: same
Description: Transitional package for libnvidia-gl-535
 This is a transitional package for libnvidia-gl-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-common-520
Architecture: all
Depends: libnvidia-common-535
Multi-Arch: foreign
Description: Transitional package for libnvidia-common-535
 This is a transitional package for libnvidia-common-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-extra-520
Architecture: i386 amd64 arm64
Depends: libnvidia-extra-535
Multi-Arch: same
Description: Transitional package for libnvidia-extra-535
 This is a transitional package for libnvidia-extra-535, and can be
 safely removed after the installation is complete.

Package: xserver-xorg-video-nvidia-520
Architecture: amd64 arm64
Depends: xserver-xorg-video-nvidia-535
Multi-Arch: same
Description: Transitional package for xserver-xorg-video-nvidia-535
 This is a transitional package for xserver-xorg-video-nvidia-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-cfg1-520
Architecture: amd64 arm64
Depends: libnvidia-cfg1-535
Multi-Arch: same
Description: Transitional package for libnvidia-cfg1-535
 This is a transitional package for libnvidia-cfg1-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-fbc1-520
Architecture: i386 amd64 arm64
Depends: libnvidia-fbc1-535
Multi-Arch: same
Description: Transitional package for libnvidia-fbc1-535
 This is a transitional package for libnvidia-fbc1-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-decode-520
Architecture: i386 amd64 arm64
Depends: libnvidia-decode-535
Multi-Arch: same
Description: Transitional package for libnvidia-decode-535
 This is a transitional package for libnvidia-decode-535, and can be
 safely removed after the installation is complete.

Package: libnvidia-encode-520
Architecture: i386 amd64 arm64
Depends: libnvidia-encode-535
Multi-Arch: same
Description: Transitional package for libnvidia-encode-535
 This is a transitional package for libnvidia-encode-535, and can be
 safely removed after the installation is complete.

Package: nvidia-driver-520-open
Architecture: amd64 arm64
Depends: nvidia-driver-535
Multi-Arch: foreign
Description: Transitional package for nvidia-driver-535
 This is a transitional package for nvidia-driver-535, and can be

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export NO_DOC_PKG_MANGLE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

include debian/rules.defs
XORG_ABI_LIST		?=
XORG_BOUND		?=

version			= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e's/.*\+really\.//')
debian_version	= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e's/.*\+really\.//')
NVIDIA_RELEASE   = $(version)
version_major		 = $(firstword $(subst ., ,$(version)))

# system libdir
libdir			?= usr/lib/$(DEB_HOST_MULTIARCH)

flavour := $(version_major)
pkg_meta         := nvidia-driver-$(flavour)
pkg_meta_open    := $(pkg_meta)-open
pkg_driver       := nvidia-$(flavour)
xorg_driver      := xserver-xorg-video-nvidia-$(flavour)
#pkg_module       := $(shell echo "$(pkg_driver)" | sed s/\-/_/g)
pkg_module       := nvidia
pkg_kernel       := nvidia-kernel-$(flavour)

ifeq ($(DEB_HOST_ARCH),amd64)
DKMS_disabled_modules :=
amd64_only :=
amd64_excluded := \#
else
amd64_only := \#
amd64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),i386)
DKMS_disabled_modules := nvidia-uvm
i386_only :=
i386_excluded := \#
else
i386_only := \#
i386_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),armhf)
DKMS_disabled_modules := nvidia-uvm
armhf_only :=
armhf_excluded := \#
else
armhf_only := \#
armhf_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),arm64)
DKMS_disabled_modules :=
arm64_only :=
arm64_excluded := \#
else
arm64_only := \#
arm64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),ppc64el)
DKMS_disabled_modules :=
ppc64el_only :=
ppc64el_excluded := \#
else
ppc64el_only := \#
ppc64el_excluded :=
endif

# i386 binaries are shipped in amd64
# Or could use ARCH_LIST to unpack all arches
ifeq ($(DEB_HOST_ARCH),i386)
unpack-stamp: NVIDIA-Linux-amd64
else
unpack-stamp: NVIDIA-Linux-$(DEB_HOST_ARCH)
endif

comma		 = ,
xorg_depends	 = $(foreach abi, $(XORG_ABI_LIST), xorg-video-abi-$(abi) |)
xorg_depends	+= $(comma) xserver-xorg-core $(XORG_BOUND)
xorg_provides	 = xorg-driver-video


.PHONY: prepare patch
prepare: unpack-stamp compare-copyright-license
patch: prepare

NVIDIA-Linux-%:
	sh $*/${NVIDIA_FILENAME_$*} --extract-only
	ln -s ${NVIDIA_DIRNAME_$*} $@
	ln -s $@ NVIDIA-Linux
	#gunzip $@/*.1.gz

# Unpack all architectures, we may need files from all of them.
unpack-stamp:
	dh_testdir
	#QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	ls -al
	touch $@

# Reformat the LICENSE to the format needed for debian/copyright.
LICENSE.txt: unpack-stamp
	sed -e 's/^ *//; s/ *$$//; s/^$$/./; s/^/ /;' NVIDIA-Linux/LICENSE > $@

# Compare the license in debian/copyright with the LICENSE shipped in the archive.
compare-copyright-license: LICENSE.txt
	sed -e '1,/^License: NVIDIA-graphics-drivers/d; 1,/^License: NVIDIA-graphics-drivers$$/d; /^$$\|^Comment:$$/,$$d; /^ \.$$/d' debian/copyright > copyright.tmp
	sed -e '/^ \.$$/d' LICENSE.txt > LICENSE.tmp
	diff -w copyright.tmp LICENSE.tmp
	rm -f copyright.tmp LICENSE.tmp

build-device-create:
	rm -f $(CURDIR)/debian/device-create/ub-device-create
	cd $(CURDIR)/debian/device-create/ && $(MAKE) all || exit 1
	@echo "ub-device-create built"

%:
	dh $@

override_dh_auto_clean:
	rm -fr .pc
	rm -f NVIDIA-Linux
	rm -fr $(foreach a,$(ARCH_LIST),NVIDIA-Linux-$a $(NVIDIA_DIRNAME_$a))
	rm -fr kernel-source-tree
	rm -f nvidia.ids nv-kernel.ids nv-readme.ids pci.ids.nvidia*
	rm -f debian/runtimepm_ids
	rm -f LICENSE.txt LICENSE.tmp copyright.tmp
	test ! -d debian/po || debconf-updatepo
	rm -f debian/$(pkg_driver).substvars
	rm -f debian/dkms.conf
	rm -f debian/device-create/ub-device-create

override_dh_clean: regen-from-templates
	dh_clean

override_dh_compress:
	dh_compress -Xsupported-gpus.json

override_dh_install:
override_dh_installinit:
override_dh_shlibdeps:

# Do not run dh_strip here.  The NVIDIA license says:
#
#     2.1.2 Linux/FreeBSD Exception.  Notwithstanding the foregoing terms of
#     Section 2.1.1, SOFTWARE designed exclusively for use on the Linux or
#     FreeBSD operating systems, or other operating systems derived from the
#     source code to these operating systems, may be copied and
#     redistributed, provided that the binary files thereof are not modified
#     in any way (except for unzipping of compressed files).
#
# Stripping the binary modules would constitute modifying the binary files
# in a way other than unzipping of compressed files.
override_dh_strip:
override_dh_strip_nondeterminism:

############################################################################

.PHONY: regen-from-templates
regen-from-templates:
	# Get rid of files belonging to different flavours
	for i in debian/templates/*.in; do \
		old=`echo $$i | sed -e "s|templates\/||g" | \
				sed -e "s|\.in\$$||g" | \
				sed -e "s|nvidia-graphics-drivers|nvidia-*|g" | \
				sed -e "s|flavour|*|g"`; \
		rm -f $$old; done
	# Create important strings
	for i in debian/templates/control.in; do \
		dest=`echo $$i | sed -e "s|templates\/||g" | \
				 sed -e "s|\.in\$$||g" | \
				 sed -e "s|flavour|$(flavour)|g"`; \
		sed -e "s|#LIBDIR#|$(libdir)|g"         \
			-e "s|#ARMHF_ONLY#|$(armhf_only)|g" \
			-e "s|#ARM64_ONLY#|$(arm64_only)|g" \
			-e "s|#AMD64_ONLY#|$(amd64_only)|g" \
			-e "s|#I386_ONLY#|$(i386_only)|g" \
			-e "s|#PPC64EL_ONLY#|$(ppc64el_only)|g" \
			-e "s|#ARMHF_EXCLUDED#|$(armhf_excluded)|g" \
			-e "s|#ARM64_EXCLUDED#|$(arm64_excluded)|g" \
			-e "s|#AMD64_EXCLUDED#|$(amd64_excluded)|g" \
			-e "s|#I386_EXCLUDED#|$(i386_excluded)|g" \
			-e "s|#PPC64EL_EXCLUDED#|$(ppc64el_excluded)|g" \
			-e "s|#NVEXCLUDEMODULES#|$(DKMS_disabled_modules)|g" \
			-e "s|#FLAVOUR#|$(flavour)|g" \
			-e "s|#DRIVERNAME#|$(pkg_driver)|g" \
			-e "s|#VERSION#|$(version)|g" \
			-e "s|#DEBIAN_VERSION#|$(debian_version)|g" \
			-e "s|#MODULENAME#|$(version)|g" \
			-e "s|#DEB_HOST_MULTIARCH#|$(DEB_HOST_MULTIARCH)|g" \
			$$i > $$dest;      \
	done

############################################################################

CACHE			?= ../.cache
ORIGDIR			?= nvidia-graphics-drivers-$(version_major).orig
TARBALL_BASE		?= nvidia-graphics-drivers-$(version_major)_$(NVIDIA_RELEASE).orig
TARBALL_SUFFIX		?= .tar.gz
TARBALL			?= $(TARBALL_BASE)$(TARBALL_SUFFIX)
ORIGDIR.empty		?= $(ORIGDIR)
TARBALL.empty		?= $(TARBALL)

# $1 = arch
get_download_url	 = $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(HTTPURL_ARCHDIR_$(strip $1))/$(NVIDIA_RELEASE)/$(NVIDIA_FILENAME_$(strip $1))
get_kern_download_url	= $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(NVIDIA_FILENAME_$(strip $1))
get_origdir		 = $(or $(ORIGDIR.$(strip $1)),$(ORIGDIR)-$(strip $1))
get_tarball		 = $(or $(TARBALL.$(strip $1)),$(TARBALL_BASE)-$(strip $1)$(TARBALL_SUFFIX))

update-runtimepm-ids:
	python3 $(CURDIR)/debian/add-ids-to-json-db \
		NVIDIA-Linux/supported-gpus/supported-gpus.json \
		$(CURDIR)/debian/additional_runtimepm_ids \
		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json

generate-runtimepm-aliases: update-runtimepm-ids
	python3 $(CURDIR)/debian/pm-aliases-gen \
		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json > $(CURDIR)/debian/runtimepm_ids
	rm -f NVIDIA-Linux/supported-gpus/supported-gpus-mod.json

generate-modaliases:
	# Generate modaliases for the restricted drivers manager
	mkdir -p $(CURDIR)/debian/$(pkg_meta)-modaliases/usr/share/jockey/modaliases/
	mkdir -p $(CURDIR)/debian/$(pkg_meta_open)-modaliases/usr/share/jockey/modaliases/
	python3 $(CURDIR)/debian/nvidia_supported \
		$(pkg_module) $(pkg_meta) \
		NVIDIA-Linux/supported-gpus/supported-gpus.json \
		> $(CURDIR)/debian/$(pkg_meta).modaliases

	python3 $(CURDIR)/debian/nvidia_supported \
		$(pkg_module) $(pkg_meta_open) \
		NVIDIA-Linux/supported-gpus/supported-gpus.json --open \
		> $(CURDIR)/debian/$(pkg_meta_open).modaliases
	# Take additional card ids from a text file
	# Generate a modalias for each ID
	@set -e -x ; \
	while read line; do \
		echo $$line | grep -Eq '^#.*' && continue; \
		for id in $$line; do \
